// ident.C
##MSTART
#include <string.h>
char *name = "ABCDEFGHIJ";
char *family="1234567890";
long serial = 12345;
int crcRT(char *str)
{
  int ln;
  int res = 0;

  ln = strlen(str);
  for (int i=0; (i< ln); i++) {
    res = (res + (unsigned) str[i]) & 0xffff;
  }
  return res;
}
 
void pident()
{
  int l = strlen(name);
  unsigned short crc;
  int crcl = 0;
 
  crcl = crcRT(name);
  crcl = (crcl + crcRT(family)) & 0xffff;
  crcl = (crcl + (serial >> 16) + (serial & 0xffff));
  crcl = (crcl & 0xffff);
  fprintf(stdcom,"char *name = \"%s\";\n",name);
  fprintf(stdcom,"char *family=\"%s\";\n",family);
  fprintf(stdcom,"unsigned long serial = %ld;\n",serial);
  fprintf(stdcom,"unsigned long crc=%ld;\n", crcl);
  return;
}
##MEND
#include <string.h>
#include <stdio.h>
//
##pident();

int crcRT(char *str)
{
  int ln;
  int res = 0;

  ln = strlen(str);
  for (int i=0; (i< ln); i++) {
    res = (res + (unsigned) str[i]) & 0xffff;
  }
  return res;
}
 
int verify()
{
  int l = strlen(name);
  int crcl = 0;
  
  crcl = crcRT(name);
  crcl = (crcl + crcRT(family)) & 0xffff;
  crcl = (crcl + (serial >> 16) + (serial & 0xffff));
  crcl = crcl & 0xffff;
  //  crcl +=1;   TO test BAD CRC case
  printf("crc=%x crc1=%x\n", crc,crcl);
  if (crcl == crc) {
    return 1;
  } else {
    return 0;
  }
}
main()
{
  if (verify() == 0)
    printf("BAD\n");
  else printf("GOOD\n");
}




